<!--
 Copyright (c) 2023 by frostime (Yp Z), All Rights Reserved.
 Author       : Yp Z
 Date         : 2023-07-02 17:05:05
 FilePath     : /src/lib/Bookmark/bookmark.svelte
 LastEditTime : 2023-07-07 21:23:42
 Description  : Compoenent of bookmark in dock
-->
<script lang="ts">
    import { onMount } from "svelte";
    import Section from "./section.svelte";
    import type { IBookmarkSection } from "$lib/types";

    export let sections: IBookmarkSection[] = [];
    export let i18n = {
        title: "Bookmarks",
        refresh: "Refresh",
        expand: "Expand",
        collapse: "Collapse",
        min: "Minimize",
        empty: "No related content found",
    }

    let expandStatus: boolean[] = [];

    function allExpand() {
        // console.log("allExpand");
        for (let i = 0; i < expandStatus.length; i++) {
            expandStatus[i] = true;
        }
    }

    function allCollapse() {
        // console.log("allCollapse");
        for (let i = 0; i < expandStatus.length; i++) {
            expandStatus[i] = false;
        }
    }

    async function refresh() {
        
    }

    const doNothing = () => {};

    onMount(() => {
        refresh();
    });
</script>

<div class="fn__flex-1 fn__flex-column file-tree layout__tab">
    <div class="block__icons">
        <div class="block__logo">
            <svg><use xlink:href="#iconBookmark" /></svg>
            {i18n.title}
        </div>
        <span class="fn__flex-1" />
        <span class="fn__space" />
        <span
            on:click={() => refresh()}
            on:keydown={doNothing}
            data-type="refresh"
            class="block__icon b3-tooltips b3-tooltips__sw"
            aria-label={i18n.refresh}
        >
            <svg class=""><use xlink:href="#iconRefresh" /></svg>
        </span>
        <span class="fn__space" />
        <span
            on:click={() => allExpand()}
            on:keydown={doNothing}
            data-type="expand"
            class="block__icon b3-tooltips b3-tooltips__sw"
            aria-label="{i18n.expand} Ctrl+↓"
        >
            <svg><use xlink:href="#iconExpand" /></svg>
        </span>
        <span class="fn__space" />
        <span
            on:click={() => allCollapse()}
            on:keydown={doNothing}
            data-type="collapse"
            class="block__icon b3-tooltips b3-tooltips__sw"
            aria-label="{i18n.collapse} Ctrl+↑"
        >
            <svg><use xlink:href="#iconContract" /></svg>
        </span>
        <span class="fn__space" />
        <span
            data-type="min"
            class="block__icon b3-tooltips b3-tooltips__sw"
            aria-label="{i18n.min} Ctrl+W"
            ><svg><use xlink:href="#iconMin" /></svg></span
        >
    </div>
    <div class="fn__flex-1">
        {#if sections.length === 0}
            <li class="b3-list--empty">{i18n.empty}</li>
        {:else}
            {#each sections as section, i}
                <Section
                    sectionTitle={section.title}
                    bind:isExpanded={expandStatus[i]}
                    items={section.items}
                />
            {/each}
        {/if}
    </div>
</div>